/******************************************************************************
!C-INC

File: cakecut.h

!Description: 
  Polygon structure and Prototypes for cakecut.c used in the MODIS LST code.

!Input Parameters:  N/A

!Output Parameters:  N/A

!Revision History:

   $Log: cakecut.h,v $
 * Revision 3.0.3 2001/08/31  16:20     Z. Wan
 *	change int to int32
 * Revision 2.3.1 2000/12/02  17:50     Z. Wan
 *	IJMAX was increased to 192 from 24
 * Revision 2.1   11/30/1998
 *  Zhengming Wan, UCSB

 * Original version:  4/16/96
 * Author: Y-T Lau,  U of Maryland, NASA/GSFC/920.2

!Team-unique Header:

!END
*****************************************************************************/

#include "mapi.h"

#ifndef CAKECUT_H
#define CAKECUT_H


#define IJMAX 192         /* max number of rows and columns of cells */

#define VMAX   8          /* 8 vertices suffice for our case */

typedef double Vertices[VMAX][2];
typedef struct {
  Vertices v;           /* array containing coordinates of vertices */
  int32 n;                /* number of vertices in polygon */
} Polygon;              /* vertices should be in clockwise order */

/* Function Prototypes */

void cakecuth(Vertices p, const int32 nm, Polygon q[], int32 *im);
void cakecutv(Vertices p, const int32 nm, double a[], int32 *im);
double area2(Vertices p, int32 n);

#endif

